<?php

	require_once("../Util/Constant.php");
	
	session_start();	
	
	require_once(CONST_DIR_DATA_PROTECTION()."/Util/Log.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/Control.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/Button.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/LinkButton.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/Dialog.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/ClientWindow.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Server/DownloadClient.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Server/InstallClient.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Server/Install.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Server/ManagerSoftwareDeployment.php");
				
	class DeployTool extends Control
	{
		//
		//	Attributes
		//
		
		var $sectionId;
		
		//
		// Buttons that are reused by different dialog boxes such as Download, Info, Cancel etc
		//
		
		var $lnkDownload;
		var $lnkDownloadOnWindows;
		var $lnkDownloadOnLinux;
		
		var $btnInfo;
		var $btnCancel;
		var $lnkInstallOnLinux;
		var $btnInstallOnWindows;
		
		//
		//	Controls that are activated during 
		//	different states
		//
		
		var $InitialLinkButton;
		var $DownloadDialog;
		var $InstallAndReDownloadDialog;
		var $DownloadClient;
		var $InstallClient;
		var $InstallerInvoke;
		var $FileInfo;
			 	
		//
		// The text of following messages is crafted by Marketing and Nearline VASE Team
		// Please preserve the contents and don't change without permission from 
		// parties involved. - Imran Salim
		//
		var $MsgInfo = "Select <b>Download</b> to get software from internet. Select <b>Info</b> for additional details.";
		var $MsgWarning = "Select <b>Info</b> for additional details"; // if info is clicked, "Please goto http://www.hp.com for more information"
		var $MsgError = "No internet connection detected. Go to <font color=darkblue>www.hp.com/go/ProtectYourData</font> to download applications and tools, and to get additional information about HP tape products.";
		
		var $MsgInstallInfo = "Your application has been downloaded. Select Install to invoke Setup program. Select Download to download application. The previously downloaded application will be overwritten.";
		var $MsgInstallWarning = "Your application has been downloaded. Select Install to invoke Setup program.";
		var $MsgInstallError = "Your application has been downloaded. Select Install to invoke Setup program.";
		
		///////////////////////////////////////////////////////////////////
		//
		//					Construction
		//
				
		function DeployTool($name, $parent, $sectionId )
		{
			$this->sectionId = $sectionId;
			
			parent::Control($name, $parent);
		}

		///////////////////////////////////////////////////////////////////
		//
		// 		Initialize Controls
		//
		function __protected__OnInit()
		{
			if ( ! $this->IsPostBack() ) // if request is coming from somewhere else, the mode is always normal
			{	
				$EnumMode = new Mode();
				$this->Mode_ = $EnumMode->NORMAL;
			}

			//--------------------------------------------------------------
			
			$software = SwDeployMANAGER( $this->sectionId );
			if ( $software == null && $software->DownloadInfo == null )
				return;

			//--------------------------------------------------------------
			//
			//	Buttons and Links
			//
			//--------------------------------------------------------------
				
			$this->lnkDownloadOnWindows = new LinkButton( "btnDownload", $this );
			$this->lnkDownloadOnWindows->Text = "Download"; // label of btnFirst
			$this->lnkDownloadOnWindows->ImageSource = CONST_URL_IMAGE()."/ButtonDownload.png";
			$this->lnkDownloadOnWindows->ClickHandler = new BtnStartDownloadClickHandler ( & $this );

			$this->lnkDownloadOnLinux = new Link( "DownloadLink", & $this );
			$this->lnkDownloadOnLinux->Label = "Start";
			$this->lnkDownloadOnLinux->Url = "ftp://".$software->Source->FTP->Url;
			$this->lnkDownloadOnLinux->DocumentName = $software->Source->FTP->Path."/".$software->Source->FTP->Filename;
			$this->lnkDownloadOnLinux->ImageSource = CONST_URL_DATA_PROTECTION()."/Image/ButtonDownload.png";
				
			$this->lnkDownload = new Link( "DownloadLink", & $this );
			$this->lnkDownload->Label = "Start";
			$this->lnkDownload->Url = "ftp://".$software->Source->FTP->Url;
			$this->lnkDownload->DocumentName = $software->Source->FTP->Path."/".$software->Source->FTP->Filename;
			$this->lnkDownload->ImageSource = CONST_URL_DATA_PROTECTION()."/Image/ButtonDownload.png";

			$this->btnInfo = new LinkButton ( "btnInfo", & $this );
			$this->btnInfo->Text = "Info";
			$this->btnInfo->ImageSource = CONST_URL_IMAGE()."/ButtonInfo.png";
			$this->btnInfo->OnClick="NewWindow('http://h18006.www1.hp.com/storage/protectyourdata.html?jumpid=PYD_web')";
			
			$this->btnCancel = new LinkButton( "btnCancel", & $this );
			$this->btnCancel->Text = "Cancel";
			$this->btnCancel->ImageSource = CONST_URL_IMAGE()."/ButtonCancel.png";
			$this->btnCancel->ClickHandler = new BtnCancelClickHandler  ( & $this );
			
			$this->lnkInstallOnLinux = new Link( "InstallLink", & $this );
			$this->lnkInstallOnLinux->Label = "Install";
			$this->lnkInstallOnLinux->Url = "file://";
			$this->lnkInstallOnLinux->DocumentName = $software->DownloadInfo->LocalPathFull();
			$this->lnkInstallOnLinux->ImageSource = CONST_URL_DATA_PROTECTION()."/Image/ButtonInstall.png";

			$this->btnInstallOnWindows = new Button( "InstallButton", & $this );
			$this->btnInstallOnWindows->Text = "Install";
			$this->btnInstallOnWindows->ClickHandler = new BtnInstallClickHandler ( & $this );

			$this->InitialLinkButton = new LinkButton("lnkBtnDownload", $this );
			$this->InitialLinkButton->Text = "Downloads and Product Info";
			$this->InitialLinkButton->ClickHandler = new LnkBtnInitializeDownloadClickHandler( & $this );

			//--------------------------------------------------------------
			//
			//	Dialog : Download
			//
			//--------------------------------------------------------------
			
			$this->DownloadDialog = new DialogBox("downloaddialog", $this );
			$this->DownloadDialog->Text = "Download Dialog";

			$this->DownloadDialog->btnFirst 	= $this->lnkDownload;
			$this->DownloadDialog->btnSecond 	= $this->btnInfo;
			$this->DownloadDialog->btnThird 	= $this->btnCancel;

			// X 
			// X Previously, the Windows code had different mechanism than Linux.
			// X Windows had a fancy dhtml based progress bar that would monitor
			// X the download progress. But it had problems, because ftp was a separate
			// X process and progress bar was managed into web server. If ftp process 
			// X freezes or terminates on partial download, the progress bar will still
			// X think that download is in progress, causing it to keep displaying indefinitely.
			// X Hence it was decided to use standard Windows download mechanism and standard 
			// X Linux mechanism for download. Hence, commenting the lines at bottom. - Imran Salim
			// X 
			// X if ( OSClientPlatform()==CONST_OS_WINDOWS() )
			// X {
			// X 	$this->DownloadDialog->btnFirst 	= $this->lnkDownloadOnWindows;
			// X 	$this->DownloadDialog->btnSecond 	= $this->btnInfo;
			// X 	$this->DownloadDialog->btnThird 	= $this->btnCancel;
			// X }
			// X else if ( OSClientPlatform()==CONST_OS_LINUX() )
			// X {
			// X 	$this->DownloadDialog->btnFirst 	= $this->lnkDownloadOnLinux;
			// X 	$this->DownloadDialog->btnSecond 	= $this->btnInfo;
			// X 	$this->DownloadDialog->btnThird 	= $this->btnCancel;
			// X }
			// X else 
			// X 	print ( "Unable to determine OS platform and hence cannot install<br/>" );
			// X 

			//--------------------------------------------------------------
			//
			//	Dialog : Install And ReDownload
			//
			//--------------------------------------------------------------
			
			$this->InstallAndReDownloadDialog = new DialogBox("Installredownload", $this );
			$this->InstallAndReDownloadDialog->Text = "Install and Download Dialog";
			
			if ( OSClientPlatform()==CONST_OS_WINDOWS() )
			{
				$this->InstallAndReDownloadDialog->btnFirst 	= $this->lnkInstallOnLinux;
				$this->InstallAndReDownloadDialog->btnSecond 	= $this->lnkDownloadOnWindows;
				$this->InstallAndReDownloadDialog->btnThird 	= $this->btnCancel;
			}
			else if ( OSClientPlatform()==CONST_OS_LINUX() )
			{
				$this->InstallAndReDownloadDialog->btnFirst 	= $this->btnInstallOnWindows;
				$this->InstallAndReDownloadDialog->btnSecond 	= $this->lnkDownloadOnLinux;
				$this->InstallAndReDownloadDialog->btnThird 	= $this->btnCancel;
			}
			else 
				print ( "Unable to determine OS platform and hence cannot install<br/>" );
			
			
			//--------------------------------------------------------------
			//
			//	Other UI Controls
			//
			//--------------------------------------------------------------
			
			$this->DownloadClient = new DownloadClient( $this->Name, $this->sectionId, CONST_URL_SERVER_DOWNLOAD() );
			$this->InstallClient = new InstallClient( $this->sectionId, CONST_URL_SERVER_INSTALL() );
			$this->InstallerInvoke = new Link("StartInstaller", $this ); // - obsolete

			parent::__protected__OnInit();
		}
		
		///////////////////////////////////////////////////////////////////
		//
		// 		On Request - This is where 'Request' is
		//			processed. Here syncronization of
		//			controls should take place from Request
		//			to variables.
		//
		
		function __protected__OnRequest()
		{
			parent::__protected__OnRequest();

			//
			// 		Process Request
			//
			
			$this->InitialLinkButton->__protected__OnRequest();
			$this->DownloadDialog->__protected__OnRequest();
			$this->InstallAndReDownloadDialog->__protected__OnRequest();
			
			// $this->RemoveDownloadButton->__protected__OnRequest();
		}
		
		///////////////////////////////////////////////////////////////////
		//
		// 		On Process - This is where drawing
		//		and displaying logic should reside
		//

		function __protected__OnProcess()
		{
			parent::__protected__OnProcess();
		}

		///////////////////////////////////////////////////////////////////
		//
		// 		On Response - This is where 'Response' is
		//			processed. Here syncronization of
		//			controls should take place from variables
		//			to Response.
		//
		
		function __protected__OnResponse()
		{
			parent::__protected__OnResponse();

			$EnumMode = new Mode();
			if ( $this->Mode_ == $EnumMode->NORMAL )
			{
				$this->InitialLinkButton->__protected__OnResponse();
				return;
			}
				
			$software = SwDeployMANAGER( $this->sectionId);

			SwDeployFixIndeterminateStates ( $software );
			
			if ( SwDeployIsDeployable($software)==false )
			{
				print ("Not enough information to deploy");
			}
			//------------------------------------------------------
			//
			//				Download
			//
			if ( $this->DownloadClient->StartInitiated==false && SwDeployIsStateDownloadInitial($software)==true )
			{
				$this->__protected__OnDownloadDialog();
			}
			else if ( $this->DownloadClient->StartInitiated==true || SwDeployIsStateDownloadInProgress($software)==true )
			{
				$this->__protected__OnDownloadInProgress();
			}
			
			// CAUTION - DEPENDENCY OF ORDER FOR 'else if' CONDITIONS BELOW
			// The two statements below should be in order.
			// Both statements may be true, if downloaded file exists
			
			else if ( SwDeployIsStateDownloadSuccessful( $software )==true )
			{
				$this->__protected__OnDownloadSuccessful();
			}
			else if ( SwDeployIsStateDownloadExist( $software )==true )
			{	// This method is similar to SwDeployIsStateDownloadSuccessful(...) except that SwDeployIsStateDownloadSuccessful(...)
				// uses ftp and internet connection to verify size of downloaded local file is same as size of remote file on ftp,
				// however, THIS METHOD SwDeployIsStateDownloadExist(...) only checks for presence of downloaded local file.
				$this->__protected__OnDownloadSuccessful();
			}
			//------------------------------------------------------
			//
			//				Install
			//
			else if ( SwDeployIsStateInstallInProgress( $software )==true )
			{
				$this->__protected__OnInstallInProgress();
			}
			else if ( SwDeployIsStateInstallSuccessful( $software )==true )
			{
				$this->__protected__OnInstallSuccessful();
			}
			//------------------------------------------------------
			//
			//				Default
			//
			else 
			{
				$this->InitialLinkButton->__protected__OnResponse();
			}
		}
		
		//
		//	Initial state in which a simple link is displayed
		//
		function __protected__OnInitialState ()
		{
			$this->InitialLinkButton->__protected__OnResponse();
			$software = SwDeployMANAGER( $this->sectionId );
			$software->DownloadInfo->SetState ( DEPLOYMENT_STATE_DOWNLOAD_IN_PROGRESS() );
			SwDeploySave( $software );
		}

		//
		// 	Displays Download Dialog, according to present or absence of internet connection and remote file
		//
		function __protected__OnDownloadDialog()
		{
			$software = SwDeployMANAGER( $this->sectionId );
	
			if ( $software->Source->FTP->ExistInternetConnection==true )
			{
					if ( $software->Source->FTP->ExistRemoteFile==true )
					{
						$this->DownloadDialog->btnFirst->Visible = true;
						$this->DownloadDialog->btnSecond->Visible = true;
						$this->DownloadDialog->btnThird->Visible = true;
						
						$this->DownloadDialog->Mode = "info";
						$this->DownloadDialog->Text = "Download Software"; // Advised by marketing. Change requires their approval
						$this->DownloadDialog->Message = $this->MsgInfo;
					}
					else // $software->Source->FTP->ExistRemoteFile==false
					{
						$this->DownloadDialog->btnFirst->Visible = false;
						$this->DownloadDialog->btnSecond->Visible = true;
						$this->DownloadDialog->btnThird->Visible = true;
		
						$this->DownloadDialog->Mode = "warning";
						$this->DownloadDialog->Text = "Information"; // Advised by marketing. Change requires their approval
						$this->DownloadDialog->Message = $this->MsgWarning; 
					}
			}
			else // No internet connection - $this->FileInfo->ExistInternetConnection==false 
			{
				$this->DownloadDialog->btnFirst->Visible = false;
				$this->DownloadDialog->btnSecond->Visible = false;
				$this->DownloadDialog->btnThird->Visible = true;
				
				$this->DownloadDialog->Mode = "error";
				$this->DownloadDialog->Text = "No Internet Connection"; // Advised by marketing. Change requires their approval
				$this->DownloadDialog->Message = $this->MsgError;
			}
			
			$this->DownloadDialog->__protected__OnResponse();
		}

		//
		// Shows download progress using a bar
		//
		function __protected__OnDownloadInProgress()
		{
			$this->DownloadClient->__protected__OnResponse();
		}
		
		//
		// Do things when download is successful
		//
		function __protected__OnDownloadSuccessful()
		{
			$software = SwDeployMANAGER( $this->sectionId );
	
			if ( $software->Source->FTP->ExistInternetConnection==true )
			{
					if ( $software->Source->FTP->ExistRemoteFile==true )
					{
						$this->InstallAndReDownloadDialog->btnFirst->Visible = true;
						$this->InstallAndReDownloadDialog->btnFirst->Visible = true;
						$this->InstallAndReDownloadDialog->btnSecond->Visible = true;
						
						$this->InstallAndReDownloadDialog->Mode = "info";
						$this->InstallAndReDownloadDialog->Text = "Install and Download Software"; // Advised by marketing. Change requires their approval
						$this->InstallAndReDownloadDialog->Message = $this->MsgInstallInfo;
					}
					else // $software->Source->FTP->ExistRemoteFile==false
					{
						$this->InstallAndReDownloadDialog->btnSecond = $this->btnInfo;
						
						$this->InstallAndReDownloadDialog->btnFirst->Visible = true;
						$this->InstallAndReDownloadDialog->btnSecond->Visible = true;
						$this->InstallAndReDownloadDialog->btnThird->Visible = true;
						
						$this->InstallAndReDownloadDialog->Mode = "warning";
						$this->InstallAndReDownloadDialog->Text = "Remote file does not exist"; // Advised by marketing. Change requires their approval
						$this->InstallAndReDownloadDialog->Message = $this->MsgInstallWarning." However, a fresh file cannot be downloaded from internet because it is not present on ftp."; 
					}
			}
			else // No internet connection - $this->FileInfo->ExistInternetConnection==false 
			{
				$this->InstallAndReDownloadDialog->btnFirst->Visible = true;
				$this->InstallAndReDownloadDialog->btnSecond->Visible = false;
				$this->InstallAndReDownloadDialog->btnThird->Visible = true;
				
				$this->InstallAndReDownloadDialog->Mode = "error";
				$this->InstallAndReDownloadDialog->Text = "No Internet Connection"; // Advised by marketing. Change requires their approval
				$this->InstallAndReDownloadDialog->Message = $this->MsgInstallError;
			}

			$this->InstallAndReDownloadDialog->__protected__OnResponse();
		}
		
		//
		// Start Installation 
		//
		function __protected__OnInstallInProgress()
		{
			$software = SwDeployMANAGER( $this->sectionId );
			return;
			
			//
			// XXX This code is only for historical reasons, and should be removed once satisfied XXX
			//
			?>
				<!-- ------------------------ INVOKING INSTALLER ----------------------------- -->
				<script language="javascript">
					NewWindow("<?php print ( "file:/".$software->DownloadInfo->LocalPathFull()); ?>")
				</script>
			<?php
			// Important to call install client, after update setting and saving state in software deploy
			$this->InstallClient->__protected__OnResponse();
		}

		//
		// Display execute link
		//
		function __protected__OnInstallSuccessful()
		{
			$software = SwDeployMANAGER( $this->sectionId );
			
			//
			// Persist information that download is completed
			//
			$executeLink = new Link( "ExecuteLink", $this );
			$executeLink->Url = $software->Installation->ExecutableFullPath();
			$executeLink->Label = "Execute Program";
			$executeLink->__protected__OnResponse();
		}
	}
	
?>

<?php

	//----------------------------------------------------------------
	//
	//					Handlers
	//
	//----------------------------------------------------------------
	
	class LnkBtnInitializeDownloadClickHandler extends ClickHandler 
	{
		function LnkBtnInitializeDownloadClickHandler ( & $deployTool )
		{
			parent::ClickHandler( $deployTool );
		}
		
		function Execute()
		{
			$EnumMode = new Mode();
			$this->control->Mode_ = $EnumMode->EDIT;
		}
	}
	
	class BtnStartDownloadClickHandler extends ClickHandler 
	{
		function BtnStartDownloadClickHandler ( & $deployTool )
		{
			parent::ClickHandler( $deployTool );
		}
		
		function Execute()
		{
			$software = SwDeployMANAGER( $this->control->sectionId, true );
			$localFile = $software->DownloadInfo->LocalPathFull();
			
			if ( file_exists( $localFile )==true )
				unlink( $localFile );
			
			$this->control->DownloadClient->Start();
		}
	}
	
	class BtnCancelClickHandler extends ClickHandler 
	{
		function BtnCancelClickHandler ( & $deployTool )
		{
			parent::ClickHandler( $deployTool );
		}
		
		function Execute()
		{
			$EnumMode = new Mode();
			$this->control->Mode_ = $EnumMode->NORMAL;
		}
	}

	class BtnInstallClickHandler extends ClickHandler 
	{
		function BtnInstallClickHandler ( & $deployTool )
		{
			parent::ClickHandler( $deployTool );
		}
		
		function Execute()
		{
			$software = SwDeployMANAGER( $this->control->sectionId );
			
			$install = new Install($software->CmdInstall, $software->DownloadInfo );
			$install->Execute();
			
			return;
		}
	}
	
?>

<!-- -----------------------------------------------------------------------

								TEST

------------------------------------------------------------------------ -->

<?php
/*
<html>
	<head></head>
	<body>
		<form action="DeployTool.php" method="POST">
			<?php
				// $deployTool = new DeployTool("deploytool", null);
				// $deployTool->Display();
			?>
		</form>
	</body>
</html>
*/
?>