<?php
	require_once("../Util/Constant.php");

	require_once(CONST_DIR_DATA_PROTECTION()."/Util/Util.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/Button.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/LinkButton.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/TextBox.php");	
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/Dialog.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Compound/DeployTool.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Compound/CompoundControl.php");
	
	class Section extends CompoundControl
	{
		var $Id;
		var $sectionHeading;
		var $description;
		var $installLocation;
		var $txtSample;

		var $educationXmlNode;
		var $downloadXmlNode;

		var $DeployTool;
		var $Show;
		
		function Section($name, $parent)
		{
			$this->sectionHeading = "";
			$this->description = "";
			$this->installLocation = "C:\\Program Files\\Software";
			parent::CompoundControl($name, $parent);
		}
		
		//
		// @description - Buidls control from $section node of xml
		// @return - true if successfuly built, false if failed to properly build
		//
		function BuildFromXmlNode ( $section )
		{
			if ( $section->node_type() != XML_ELEMENT_NODE )
			{
				print ("Error ! unexpected xml format in Section Control.<br/>");
				return false;
			}
			
			$xmlattrLocal = $section->get_attribute("Local");
			$xmlattrRemote = $section->get_attribute("Remote");

			if ( IsRequestLocal()==true && $xmlattrLocal == "false" ) 
			{
				// undesirable condition				
				return false;
			}
			
			if ( IsRequestRemote()==true && $xmlattrRemote == "false" )
			{
				// undesirable condition				
				return false;
			}

			//
			// Todo : To be removed, after thorough testing of xml file with remote and location combinations as true and false
			// Commented By : Imran Salim
			//
			//  else if ( (  $xmlattrLocal == "true" && IsRequestLocal()==true ) || ( $xmlattrRemote == "true" && IsRequestRemote()==true ) ) 
			// { 
			// 		good condition
			// }

			$this->Id = $section->get_attribute("ID");
			
			$h = $section->get_elements_by_tagname("Heading");
			if ( $h != null && count ( $h ) > 0 )
			{
				$heading = $h[0];
				$this->sectionHeading 	= $heading->get_content();
				// __PrintLine__("HEADING=".$heading->get_content());
			}
			
			$xmlnodeDescription = $section->get_elements_by_tagname("Description");
			if ( $xmlnodeDescription != null && count ( $xmlnodeDescription ) > 0 )
			{
				$this->description = new Description( $this );
				$this->description->BuildFromXml ( $xmlnodeDescription[0] );
			}
			
			//
			// 		Download and DeployTool
			//
			$dnl = $section->get_elements_by_tagname("Download");
			if ( $dnl != null && count ( $dnl ) > 0 )
			{
				$download = $dnl[0];
				$this->downloadXmlNode = $download;
			}

			//
			// 		Education
			//
			$e = $section->get_elements_by_tagname("Education");
			if ( $e != null && count ( $e ) > 0 )
			{
				$education = $e[0];
				$this->educationXmlNode = $education;
			}

			return true;
		}
		
		//////////////////////////////////////////////////
		//
		// 		On Request - This is where 'Request' is
		//			processed. Here syncronization of
		//			controls should take place from Request
		//			to variables.
		//
		function __protected__OnRequest()
		{
			parent::__protected__OnRequest();
			
			if ( $this->downloadXmlNode != null )
			{
				$this->DeployTool = new DeployTool($this->Name, $this, $this->Id );
				$this->DeployTool->__protected__OnRequest();
			}
			if ( $this->educationXmlNode != null )
			{
				$this->Show = new SlideShow("__slide_show__", $this /* parent */);
				$this->Show->xmlNode = $this->educationXmlNode;
				// $show->SetTransition("fade"); - default is random
				$this->Show->Width = '300px';
				$this->Show->Height = '275px';
			}
		}
			
		function __protected__OnRequestNormal()
		{
		}

		function __protected__OnRequestSelect()
		{
		}

		function __protected__OnRequestEdit()
		{
		}

		//////////////////////////////////////////////////
		//
		// 		On Process - This is where drawing
		//		and displaying logic should reside
		//
		function __protected__OnProcess()
		{
			parent::__protected__OnProcess();
		}

		function __protected__OnProcessNormal()
		{
		}

		function __protected__OnProcessSelect()
		{
		}

		function __protected__OnProcessEdit()
		{
		}
			
		//////////////////////////////////////////////////
		//
		// 		On Response - This is where 'Response' is
		//			processed. Here syncronization of
		//			controls should take place from variables
		//			to Response.
		//
		function __protected__OnResponse()
		{
			print ( "<table>");
				print ("<tr>");	
					print ("<td valign=top>");
					
						if ( $this->sectionHeading != null && $this->sectionHeading != '' )
							print ( "<a name='$this->Id'>");
							print ( "<div class='SectionHeadingStyle'>".$this->sectionHeading."</div>" );
							print ( "</a>" );
						
						$this->description->Print_();
						
						parent::__protected__OnResponse();
						
						if ( $this->DeployTool != null )
							$this->DeployTool->__protected__OnResponse();
						
					print ("</td>");
					print ("<td valign=top>");
						
						if ( $this->Show != null )
							$this->Show->__protected__OnResponse();
							
					print ("</td>");
				print ("</tr>");
				
			print ( "</table>");
									
			print ( "<div align='right'>" );
				$lnkTop = new Link("lnkTop", $pageItem);
				$lnkTop->Url = "#";
				$lnkTop->DocumentName = "Top";
				$lnkTop->Label = "Top";
				$lnkTop->Display();
			print ( "</div>" );
		}
			
		function __protected__OnResponseNormal()
		{
		}
			
		function __protected__OnResponseSelect()
		{
		}
			
		function __protected__OnResponseEdit()
		{
		}
	}
			
	class Description 
	{
		var $section;
		var $textLimit;
		var $paragraphList = array();
		
		function Description ( $section )
		{
			$this->section = $section;
		}
		
		function BuildFromXml ( $xmlnodeDescription )
		{
			$this->textLimit = $xmlnodeDescription->get_attribute ( "TextLimit" );
			$xmlnodeParagraphList = $xmlnodeDescription->get_elements_by_tagname ("Paragraph");
			foreach ( $xmlnodeParagraphList as $xmlnodeParagraph )
			{
				$p = $xmlnodeParagraph->get_content();
				$this->Add( $p );
			}
		}

		function DoTrim()
		{
			if ( $this->textLimit == null || $this->textLimit < 0 )
				return false;
			else 
				return  true;
		}
		
		function Add ( $p )
		{
			array_add( $this->paragraphList, $p );
		}
		
		function Print_ ()
		{
			$totalLen = 0;
			$done = false;
						
			foreach ( $this->paragraphList as $paragraph )
			{
				$totalLen += strlen( $paragraph );
				
				// print ( "Total Len = ".$totalLen.", Limit = ".$this->textLimit." " );
				
				//
				// Prepare Text for displaying in dialog box
				//
				if ( $this->DoTrim()==true && $totalLen >= $this->textLimit )
				{
					$extraLen = $totalLen - $this->textLimit;
					$paraLen = strlen( $paragraph );
					$subParaLen = $paraLen - $extraLen;
					
					$paragraphAll = "";
					$paragraphAll .= "<hr/>";
					$paragraphAll .= "<div class='SectionHeadingStyle'>".$this->section->sectionHeading."</div>";
					$paragraphAll .= "<hr/>";
					foreach ( $this->paragraphList as $para )
					{
						$paragraphAll .= "<div>".$para."</div>"."<br/>";
					}
					$paragraphAll .= "<hr/>";
					
					$subParagraph = substr( $paragraph, 0, $subParaLen - 1 );
					
					// Bug Fix : Observe that paragraph is now sub-paragraph
					$paragraph = $subParagraph;
					$paragraph .= ". . . ";
					$paragraph .= "<a style='color:black;font-size:11;' href=# onClick=\"OpenDialog(moreText_".$this->section->InstanceName().")\"> MORE INFO </a>";	/* Variable passed as mroeText is defined below */

					print ( "<script language=javascript>"); // place more text in javascript
					print ( "moreText_".$this->section->InstanceName()."=\"".$paragraphAll."\"" );
					print ( "</script>");
					
					$done = true;
				}

				print ( "<div class='SectionDescriptionStyle' >".$paragraph."</div>" );
				
				if ( $done == true )
					break;
			}
		}
	}
	
	class UploadClickHandler extends ClickHandler
	{
		function  UploadClickHandler ( & $control )
		{
			parent::ClickHandler( & $control );
		}
		
		function Execute()
		{
			$this->control->Mode_ = "normal";						
		}
	}

	class CancelClickHandler extends ClickHandler
	{
		function  CancelClickHandler ( & $control )
		{
			parent::ClickHandler( & $control );
		}
		
		function Execute()
		{
			$this->control->Mode_ = "normal";						
		}
	}

	class EditClickHandler extends ClickHandler
	{
		function EditClickHandler ( & $control )
		{
			parent::ClickHandler( & $control );
		}
		
		function Execute()
		{
			$this->control->Mode_ = "edit";
		}
	}
?>