<?php

	// BUG FIX : CAUTION : Any class that is stored in session,
	// serialized 'n deserialized, should be included before 
	// starting the session. This is important because php
	// interpretor will know the definition of class, when
	// session is being re-created for each consequetivee request.
	// Commented By : Imran Salim

	require_once("../Util/Constant.php");
	
	session_start();

	require_once(CONST_DIR_DATA_PROTECTION()."/Control/ProgressBar.php" );
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/LinkButton.php" );
	require_once(CONST_DIR_DATA_PROTECTION()."/Server/ManagerSoftwareDeployment.php");

?>

<!-- -------------------------------------------------------------------------
------------------------------------------------------------------------------

					Progress Bar [Client]
					
------------------------------------------------------------------------------					
-------------------------------------------------------------------------- -->
<?php

	class DownloadClient extends Control 
	{
		var $Title = "Download";
		var $ServerURL = ''; // url of server running this code
		var $SectionId;
		var $LinkButtonCancel;
		var $StartInitiated = false;
		
		function DownloadClient ( $name, $sectionId, $serverUrl )
		{
			parent::Control($name, null); 	// Todo : always pass null for parent because parent helps in forming full name to make it unique. 
											// 		In case of download, server and client may reside on different parent controls, thus forming
											//		different fullnames and causing confusion b/w server and client, while finding each other. 
											//		full name of a control is it's own name + parent name + parent's parent's name + .....
			$this->ServerURL = $serverUrl;
			$this->SectionId = $sectionId;
		}

		function Start()
		{
			$this->StartInitiated = true;
		}
		
		function Terminate()
		{
			print ( "TODO : File=".__FILE__.", Class=".__CLASS__.", Function=".__FUNCTION__.", Line=".__LINE__."<br/>" );
		}
		
		function __protected__OnInit()
		{
			$this->LinkButtonCancel = new LinkButton("lnkButtonCancel", & $this );
			$this->LinkButtonCancel->Text = "Terminate";
		}
		
		function __protected__OnRequest()
		{
			parent::__protected__OnRequest();
			
			$this->LinkButtonCancel->__protected__OnRequest();
		}
		
		function __protected__OnResponse()
		{
			parent::__protected__OnResponse();
			
			$software = SwDeployMANAGER( $this->SectionId );
			
			// $downloading = SwDeployIsStateDownloadInProgress( $software );
			$downloadInitialState = SwDeployIsStateDownloadInitial( $software );
			$downloadSuccessful = SwDeployIsStateDownloadSuccessful( $software );
			
			if ( $downloadInitialState==true && $this->StartInitiated==false )
			{
				print ("Click <u>here</u> to download");
				return; // don't display control, if download is in initial state and start is not clicked
			}	
			if ( $downloadSuccessful==true )
			{
				print ("File already downloaded - <u>Remove</u>");
				return;
			}
			
			if ( $downloadInitialState==true && $this->StartInitiated==true )
			{	
				// TO DO - PROBLEM - INITIATE DOWNLOAD ONCE -
				// 			Start Downloading, by calling a page in the frame (below). Logic is to initiate that download process by visiting
				// 			the page below only one time, and then keep updating client side using ProcessBarClient. The initiation of
				//			download by visiting page below ( FTPCommand.php ) is only performed once
				
				?>
					<?php 
						
						//
						// PART I of III - Builds Script of FTP
						//
							
						if ( OSClientPlatform()==CONST_OS_WINDOWS() )
						{
							$cgiFtp = "CgiFTP.exe";
						}
						else if ( OSClientPlatform()==CONST_OS_LINUX() )
						{
							$cgiFtp = "CgiFTP";
						}
						else 
						{
							print ( __FILE__." ".__LINE__." - Unknown Operating System.<br/>");
							exit(-1);
						}

						$ftpScriptName = BuildFTPScript( $this->SectionId ); 
					
					?>
					
					<?php
					//
					// PART II of III - Call Cgi Program (with parameters) that uses Ftp script, built in PART I
					//
					?>
					
					<iframe id="downloadFrame_<?php $this->mangle();?>" height="0" width="0" frameborder=no scrolling=no src="/cgi-bin/<?php print ( $cgiFtp ); ?>?SectionInfo=<?php print ( $ftpScriptName ); ?>" >

						<!-- OS command is issed using this iframe -->

						<!-- Why Frame is used : It is also possible that PHP code is placed here that calls OS ftp command,
							 and not called from frame (as in this case) that will initiate download process, but problem
							 is that the approach without frame cause browser to keep waiting for 'end response' signal, 
							 eventhough the browser has been redirected to a different location using javascript on
							 this page. Using a frame and asking frame to go to a different location and then redirecting
							 this window prevents browser from waiting for 'end response' signal.
							 
							 Commented By : Imran Salim
						-->

					</iframe>
					
					<script language="javascript">
					
						// Only constructed when starting to download. Only used to cleanup frame 
						// after 5 seconds, however, it is not absolutely required to have. 
						// Commented By :s Imran Salim
						function MoveToBlankPage_<?php $this->mangle();?>()
						{
							if (downloadFrame_<?php $this->mangle();?> != undefined ) 
							{
								downloadFrame_<?php $this->mangle();?>.location.href = "/DataProtection/Server/Blank.php";
							}
							if ( timerID_<?php $this->mangle();?> != undefined )
								clearTimeout ( timerID_<?php $this->mangle();?> );
						}
						timerID_<?php $this->mangle();?> = setTimeout ("MoveToBlankPage_<?php $this->mangle();?>()", 1000);

					</script>
					
				<?php
			}
		
			//
			// PART III or III - Displays progress update. Informs ProgressBarClient, which server to look for progress update.
			//
			
			$pb = new ProgressBarClient( "progress_bar", $this, $this->ServerURL."?SectionId=".$this->SectionId );
			$pb->Title = $this->Title;

			?>
				<table border="0">
					<tr>
						<td>
							<?php $pb->__protected__OnResponse(); ?>
						</td>
					</tr>
					<tr >
						<td width="200" align="right">
							<!-- 
							<?php $this->LinkButtonCancel ->__protected__OnResponse(); ?>
							-->
						</td>
					</tr>
					
				</table>
			<?php
		}
	}

?>



<!-- ---------------------------------------------------------------------------------
--------------------------------------------------------------------------------------
							
						BuildFTPScript
							
--------------------------------------------------------------------------------------							
--------------------------------------------------------------------------------- -->

<?php

	require_once("../Util/Constant.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Util/Guid.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Util/Platform.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Server/InfoFtp.php");
		
	function BuildFTPScript( $sectionId )
	{
		if ( OSClientPlatform()==CONST_OS_WINDOWS() )
			return BuildFTPScriptWindows( $sectionId );
		else if ( OSClientPlatform()==CONST_OS_LINUX() )
			return BuildFTPScriptLinux( $sectionId );
		return 
			"UnableToBuildScript";
	}
	
	function BuildFTPScriptWindows( $sectionId )
	{
		$software = SwDeployMANAGER( $sectionId );
		$fileInfo = $software->Source->FTP;
		$downloadInfo = $software->DownloadInfo;
		
		// Create script for downloading
		$fname = NewGuid().".ftp"; // Security Measure - a unqiue filename for every download request
		$file = fopen( CONST_DIR_SERVER_DOWNLOAD()."/".$fname, "wb" );
		fwrite( $file, "open ".$fileInfo->Url."\r\n" );
		fwrite( $file, $fileInfo->Username."\r\n" );
		fwrite( $file, $fileInfo->Password."\r\n" );
		fwrite( $file, "binary"."\r\n");
		// fwrite( $file, "cd ".$fileInfo->remoteFilePath."\r\n" );
		// The line below (get method) has two parts - 1. Remote filename and 2. Local filename along with local path
		fwrite( $file, "get \"".$fileInfo->Path."/".$fileInfo->Filename."\" \"".$downloadInfo->LocalPathFull()."\"\r\n" );
		fwrite( $file, "quit"."\r\n" );
		fclose( $file );
		
		$old_error_level = error_reporting(0);
		mkdir ( $downloadInfo->LocalPath ); // Ensure that directory exists
		error_reporting( $old_error_level );
			
		// return file name
		return $fname;
	}

	function BuildFTPScriptLinux( $sectionId )
	{
		$software = SwDeployMANAGER( $sectionId );
		$fileInfo = $software->Source->FTP;
		$downloadInfo = $software->DownloadInfo;
		
		// Create script for downloading
		$fname = NewGuid().".ftp"; // Security Measure - a unqiue filename for every download request
		$file = fopen( CONST_DIR_SERVER_DOWNLOAD()."/".$fname, "wb" );
		fwrite( $file, "open ".$fileInfo->Url."\n" );
		fwrite( $file, "user ".$fileInfo->Username." ".$fileInfo->Password."\n" );
		fwrite( $file, "binary"."\n");
		// fwrite( $file, "cd ".$fileInfo->remoteFilePath."\n" );
		// The line below (get method) has two parts - 1. Remote filename and 2. Local filename along with local path
		fwrite( $file, "get \"".$fileInfo->Path."/".$fileInfo->Filename."\" \"".$downloadInfo->LocalPathFull()."\"\n" );
		fwrite( $file, "bye"."\n" );
		fclose( $file );
		
		$old_error_level = error_reporting(0);
		mkdir ( $downloadInfo->LocalPath ); // Ensure that directory exists
		error_reporting( $old_error_level );
			
		// return file name
		return $fname;
	}
?>