<?php

	require_once("../Util/Constant.php");
	
	session_start();	
	
	require_once(CONST_DIR_DATA_PROTECTION()."/Util/Log.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Util/String.php");
	
	class Install
	{
		var $CmdInstall;
		var $DownloadInfo;
		
		function Install( $cmdInstall, $downloadInfo )
		{
			$this->CmdInstall = $cmdInstall;
			$this->DownloadInfo = $downloadInfo;
		}
		
		function Execute()
		{
			if ( $this->CmdInstall->OS == CONST_OS_LINUX() )
			{
				$this->__private__Linux__Install();
			}
			else if ( $this->CmdInstall->OS == CONST_OS_WINDOWS() )
			{
				$this->__private__Windows__Install();
			}
			else 
			{
				print ("Unspecific operating system to install.<br/>");
				print ("Please report this error to program vendor.<br/>");
			}
		}
		
		function __private__Linux__Install()
		{
			//
			// Extracting and forming variables
			//
			
			// Local download path
			$localPath 	= $this->DownloadInfo->LocalPath;
			// The downloaded file. This file may have .tar.gz extention
			$localFile 	= $this->DownloadInfo->LocalFile;
			// Directory, into which files are un-compressed
			$dirExtract = $this->CmdInstall->DirExtract;
			// File after un-compressing, that is executed
			$setupFile 	= $this->CmdInstall->SetupFile; 

			// @ print ( $localPath.",".$localFile.",".$dirExtract.",".$setupFile."<br/>" );
			
			$localFilePath = $localPath."/".$localFile;
			
			// Preserve name of original directory and change to 
			// directory where file is downloadeds - Imran Salim
			$originalDir = getcwd();
			chdir( $localPath );
			
			//
			// RPM Installation
			//
			if ( $this->CmdInstall->RpmInstall == true )
			{
				if ( StrEndsWith( $localFilePath, ".rpm")==true )
				{
					exec ( "/bin/rpm -i ".$localFilePath );
					
					// Go back to oringinal directory
					chdir( $originalDir );
					
					return;
				}
				else 
				{
					print ( __CLASS__." line:".__LINE__." UnExpected condition encountered. Install FAILED <br/>" );
				}
			}
			
			//
			// GUnzip and Tar Installation
			//
			if ( $this->CmdInstall->UnZip == true )
			{
				if ( StrEndsWith( $localFilePath, ".gz" )==true )
				{
					exec ( "/bin/gunzip ".$localFilePath );
					$localFilePath = substr( $localFilePath, 0, -3 /* remove .gz from end */ );
				}
			}
			
			if ( $this->CmdInstall->UnTar == true )
			{
				if ( StrEndsWith( $localFilePath, ".tar")==true )
				{
					exec ( "/bin/tar -xvf ".$localFilePath );
					$localFilePath = substr ( $localFilePath, 0, -4 /* remove .tar from end */ );
				}
			}
			
			//
			// Execute setup script or binary
			//
			$setupPath = $localPath;
			$setupPath .= ( isset($dirExtract)==true && $dirExtract != "" ) ? "/".$dirExtract : "";
			$setupPath .= "/".$setupFile;
				
			exec ( $setupPath );
			
			//
			// Go back to oringinal directory, before exiting this function
			//
			chdir ( $originalDir );
		}
		
		function __private__Windows__Install()
		{
			// Current implementation is in deploy tool itself, that
			// uses link, instead of issuing any os command
		}
	}
?>