<?php
error_reporting(E_ALL ^ E_WARNING ^ E_NOTICE);

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

function ObtainFileSemaphore($filename, $timeout)
{
  $lockObtained = false;
  for ($i = 0; $lockObtained == false && $i < $timeout; $i++)
  {
    // "x+" is equivalent to specifying O_EXCL|O_CREAT flags for the underlying open(2) system call
    // for both reading and writing
    // The "O_CREAT | O_EXCL" combination causes the opn to fail if the file already exists.
    // The reading and writing permissions are both necessary, so that we can delete the file to free the mutex.
    $handle = @fopen($filename, "x+");
    if ($handle == FALSE)
    {
      sleep(1); // sleep for 1 second
    }
    else
    {
      $lockObtained = true;
      fclose($handle);
      break;
    }
  }
  
  return $lockObtained;
}

function ExecuteIOCommand ($executableName, $stdinData, &$stdoutData, &$stderrData)
{
  //if ($_SESSION["semaphore"] != "locked")
  //{
    //$_SESSION["semaphore"] = "locked";
    $sessionSavePath = session_save_path();
    $sessionID = session_id();

    $semaphoreFilename =  $sessionSavePath . "/semaphore_" . $sessionID;

    $stdinFilename = $sessionSavePath . "/stdin_" . $sessionID;
    $stdoutFilename = $sessionSavePath . "/stdout_" . $sessionID;
    $stderrFilename = $sessionSavePath . "/stderr_" . $sessionID;

    $fd = @fopen($stdinFilename, "w");
    @fwrite($fd, $stdinData);
    @fclose($fd);

    $return_value = 1;
    $stdoutData = "";
    $stderrData = "";
    system($executableName . " <" . $stdinFilename . " 1>" . $stdoutFilename . " 2>" . $stderrFilename, $return_value);
    $stdoutData = @file_get_contents($stdoutFilename);
    $stderrData = @file_get_contents($stderrFilename);

    // cleanup
    @unlink($stdinFilename);
    @unlink($stdoutFilename);
    @unlink($stderrFilename);

    @unlink($semaphoreFilename); // release semaphore
    //$_SESSION["semaphore"] = "unlocked";
  //}
  //else
    //echo "<script language='javascript'>\nalert('locked');\n</script>\n";
  return $return_value;
}
?>
